--BAJA PROPIETARIO
create or replace PROCEDURE "SP_BAJA_PROPIETARIO"

            (IDPROPIETARIO IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            
            BEGIN
        
            -- DOY DE BAJA EL PROPIETARIO
            
                UPDATE SCCI_PROPIETARIO SET ACTIVO = 0 WHERE (IDPROPIETARIO = IDPROPIETARIO);
            

            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN
                
                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PROPIETARIO', 'BAJA_PROPIETARIO: '||IDPROPIETARIO||'', SYSDATE(), RSP);
              
                RETURN;
              
                -- EN CASO DE ERROR              
                EXCEPTION
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
                      -- MODIFICO ENTONCES LA ENTRADA EN EL LOG CON EL ERROR ESPECIFICADO EN RSP
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PROPIETARIO', 'BAJA_PROPIETARIO: '||IDPROPIETARIO||'', SYSDATE(), RSP);
                  
                        RETURN;

END;
END;

/




--BAJA PARCELA
create or replace PROCEDURE "SP_BAJA_PARCELA"

            (IDPARCELA IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            RESPUESTA VARCHAR(500);
            
            BEGIN
        
           -- DOY DE BAJA LA PARCELA
            UPDATE SCCI_PARCELA SET ACTIVO = 0 WHERE (IDPARCELA = IDPARCELA);
            
            --ACTUALIZO ESTADISTICAS
            
              SP_ESTADISTICA_3(RESPUESTA);
              SP_ESTADISTICA_5(RESPUESTA);
              SP_ESTADISTICA_8(RESPUESTA);
              SP_ESTADISTICA_9(RESPUESTA);           
                          
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            -- REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PARCELA', 'BAJA_PARCELA: '||IDPARCELA||'', SYSDATE(), RSP);
              
              
                RETURN;
              
                -- EN CASO DE ERROR              
                EXCEPTION
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PARCELA', 'BAJA_PARCELA: '||IDPARCELA||'', SYSDATE(), RSP);
                  
                        RETURN;
          
END;
END;

/



--BAJA VEGETACION
create or replace PROCEDURE "SP_BAJA_VEGETACION"

            (IDVEGETACION IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
                   
            -- DOY DE BAJA LA VEGETACION
            UPDATE SCCI_VEGETACION SET ACTIVO = 0 WHERE (IDVEGETACION = IDVEGETACION);
            
            -- INSERTO LA OPERACION EN EL LOG
            RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN
            
            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'BAJA_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                                                  
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'BAJA_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/




--BAJA DENSIDAD 
create or replace PROCEDURE "SP_BAJA_DENSIDAD"
            
            (IDDENSIDAD IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
               
            -- DOY DE BAJA LA DENSIDAD
            UPDATE SCCI_DENSIDAD SET ACTIVO = 0 WHERE (IDDENSIDAD = IDDENSIDAD);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN
    
            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'DENSIDAD', 'BAJA_DENSIDAD: '||IDDENSIDAD||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                          
                WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'DENSIDAD', 'BAJA_DENSIDAD: '||IDDENSIDAD||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/


--BAJA PENDIENTE 
create or replace PROCEDURE "SP_BAJA_PENDIENTE"

            (IDPENDIENTE IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
            -- DOY DE BAJA LA PENDIENTE
            UPDATE SCCI_PENDIENTE SET ACTIVO = 0 WHERE (IDPENDIENTE = IDPENDIENTE);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'BAJA_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
                            
                RETURN;
      
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                                      
                WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'BAJA_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/



--BAJA PLUVIOMETRIA 
create or replace PROCEDURE "SP_BAJA_PLUVIOMETRIA"

            (IDPLUVIOMETRIA IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
            
            -- DOY DE BAJA LA PLUVIOMETRIA
            UPDATE SCCI_PLUVIOMETRIA SET ACTIVO = 0 WHERE (IDPLUVIOMETRIA = IDPLUVIOMETRIA);
            
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'BAJA_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
              
                RETURN;
     
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                                
                WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'BAJA_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
                  
                          RETURN;

END;
END;

/

--BAJA EROSION 
create or replace PROCEDURE "SP_BAJA_EROSION"

            (IDEROSION IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
            -- DOY DE BAJA LA EROSION
            UPDATE SCCI_EROSION SET ACTIVO = 0 WHERE (IDEROSION = IDEROSION);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

            -- REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'BAJA_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
              
              
                RETURN;
     
             -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION

                WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'BAJA_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/




--BAJA RIESGO 
create or replace PROCEDURE "SP_BAJA_RIESGO"

            (IDRIESGO IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
            -- DOY DE BAJA EL RIESGO
            UPDATE SCCI_RIESGO SET ACTIVO = 0 WHERE (IDRIESGO = IDRIESGO);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'RIESGO', 'BAJA_RIESGO: '||IDRIESGO||'', SYSDATE(), RSP);
              
              
                RETURN;
                      
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                                      
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'RIESGO', 'BAJA_RIESGO: '||IDRIESGO||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/


--BAJA INCENDIO 
create or replace PROCEDURE "SP_BAJA_INCENDIO"

            (IDINCENDIO IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            ANUALIDADLOCAL NUMBER;
            IDPARCELALOCAL NUMBER(10,0);
            RESPUESTA VARCHAR(1000);
            FECHA DATE;
       
            BEGIN
        
        
        -- SELECCIONO LA FECHA DEL INCENDIO CON ESE ID  PARA PODER ACTUALIZAR LA ESTADISTICA PARA EL AO EN EL QUE BORRO EL INCENDIO
             SELECT FECHA INTO FECHA FROM SCCI_INCENDIO WHERE IDINCENDIO = IDINCENDIO;
        
        -- SELECCIONO LA PARCELA DEL INCENDIO CON ESE ID PARA PODER ACTUALIZAR LA ESTADISTICA
            SELECT IDPARCELA INTO IDPARCELALOCAL FROM SCCI_INCENDIO WHERE IDINCENDIO = IDINCENDIO;
        
            -- ACTUALIZO LA ESTADISTICA 1 EN UNA VARIABLE LOCAL
            ANUALIDADLOCAL:= EXTRACT (YEAR FROM FECHA);
                 
       
      

              
            -- DOY DE BAJA EL INCENDIO
            UPDATE SCCI_INCENDIO SET ACTIVO = 0 WHERE (IDINCENDIO = IDINCENDIO);
      
            -- LLAMO AL PROCEDIMIENTO CON LAS VARIABLES LOCALES PARA ACTUALIZAR LAS ESTADISTICAS
            -- EN BASE A LOS DATOS PASADOS COMO PARAMETRO
              
              SP_ESTADISTICA_1(ANUALIDADLOCAL, IDPARCELALOCAL, RESPUESTA);
              SP_ESTADISTICA_3(RESPUESTA);
              SP_ESTADISTICA_5(RESPUESTA);
              SP_ESTADISTICA_7(RESPUESTA);      
              
              
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN
  

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'INCENDIO', 'BAJA_INCENDIO: '||IDINCENDIO||'', SYSDATE(), RSP);
                      
              
                RETURN;
                      
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                                      
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'INCENDIO', 'BAJA_INCENDIO: '||IDINCENDIO||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/





--BAJA EMPRESA 
create or replace PROCEDURE "SP_BAJA_EMPRESA"

            (IDEMPRESA IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
            
            
            -- DOY DE BAJA LA EMPRESA
            UPDATE SCCI_EMPRESA SET ACTIVO = 0 WHERE (IDEMPRESA = IDEMPRESA);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EMPRESA', 'BAJA_EMPRESA: '||IDEMPRESA||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EMPRESA', 'BAJA_EMPRESA: '||IDEMPRESA||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/


--BAJA PLAN
create or replace PROCEDURE "SP_BAJA_PLAN"

            (IDPLAN IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        

            -- DOY DE BAJA EL PLAN
            UPDATE SCCI_PLAN SET ACTIVO = 0 WHERE (IDPLAN = IDPLAN);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLAN', 'BAJA_PLAN: '||IDPLAN||'', SYSDATE(), RSP);
              
              
                RETURN;
              
                -- EN CASO DE ERROR              
                EXCEPTION
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLAN', 'BAJA_PLAN: '||IDPLAN||'', SYSDATE(), RSP);
                  
                          RETURN;
                          


     
END;
END;

/


--BAJA SUBVENCION 
create or replace PROCEDURE "SP_BAJA_SUBVENCION"

            (VIDSUBVENCION IN NUMBER,
            RSP OUT VARCHAR
            )
            
            IS
            BEGIN
            DECLARE
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
         
                       
          
            BEGIN
       
       
            -- DOY DE BAJA LA SUBVENCION A ESTADO = 4 (CANCELADA)
            UPDATE SCCI_SUBVENCION SET ESTADO = 4 WHERE (IDSUBVENCION = IDSUBVENCION);
                     
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'BAJA_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'BAJA_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
                          
END;

/




--BAJA TRABAJOS 
create or replace PROCEDURE "SP_BAJA_TRABAJOS"

            (VIDTRABAJO IN NUMBER,
            RSP OUT VARCHAR
            )
            
            IS
            BEGIN
            DECLARE
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);

            
            BEGIN
    
                   
            -- CANCELO EL TRABAJO A ESTADO = 3 (CANCELADO)
            UPDATE SCCI_TRABAJOS SET ESTADO = 3 WHERE (IDTRABAJO = IDTRABAJO);

            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'BAJA_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                

                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
                     -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'BAJA_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
                          
END;

/



--BAJA PETICION 
create or replace PROCEDURE "SP_BAJA_PETICION"
        (VIDPETICION IN NUMBER,
            RSP OUT VARCHAR
            )
            
            IS
            BEGIN
            DECLARE
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
           
            BEGIN
            

            -- DOY DE BAJA LA PETICION A ESTADO = 4 (CANCELADA)
            UPDATE SCCI_PETICION SET RESOLUCION = 4 WHERE (IDPETICION = IDPETICION);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'BAJA_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'BAJA_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
     
                        RETURN;
                          
END;
                          
END;

/


