
-- ESTADISTICA 1
-- ESTE PROCEDIMIENTO SE TENDR QUE EJECUTAR CADA VEZ QUE SE INTRODUZCA UN INCENDIO.
-- LOS INCENDIOS AFECTAN A UNA O VARIAS PARCELAS.
-- EL SUMATORIO DE TODOS LOS CAMPOS SUPERFICIE DE LAS PARCELAS QUE ESTAN EN LA TABLA INCENDIO SER EL RESULTADO DE LA CONSULTA.
-- HAY MUCHAS MANERAS DE HACERLO. PUEDO REALIZAR UNA CONSULTA CADA VEZ A LA TABLA PARCELAS O BIEN TENER UNA VARIABLE QUE VAYA
-- SUMANDO TODAS LAS SUPERFICIES A MEDIDA QUE SON AFECTADAS. OPTAR POR ESTA SEGUNDA YA QUE REALIZAR LA CONSULTA CADA VEZ SUPONDR
-- UN COSTE DE RECURSOS IMPORTANTE

CREATE OR REPLACE PROCEDURE "SP_ESTADISTICA_1"
(VANUALIDAD IN NUMBER,
VIDPARCELA IN NUMBER,
RESPUESTA OUT CHAR)
IS
BEGIN  

DECLARE

ERR_NUM NUMBER;
ERR_MSG VARCHAR2(255);
SUPERFICIEAFECTADAHISTORICA NUMBER;
SUPERFICIEAFECTADA NUMBER;
SUPERFICIEAFECTADATOTAL NUMBER;
HAYDATOS NUMBER:=0;

BEGIN

-- PRIMERO CONSULTO EL TERRENOAFECTADO HISTORICO MIRANDO PRIMERO QUE HAYA DATOS PARA QUE NO ME D ERROR
SELECT COUNT(*) INTO HAYDATOS FROM SCCI_ESTADISTICA1 WHERE ANUALIDAD = VANUALIDAD;
IF (HAYDATOS <> 0) THEN
SELECT SUPERFICIE INTO SUPERFICIEAFECTADAHISTORICA FROM SCCI_ESTADISTICA1 WHERE ANUALIDAD = VANUALIDAD;
HAYDATOS:=0; --INICIALIZO DE NUEVO DE LA VARIABLE
END IF;

-- CONSULTO LA SUPERFICIE DE LA PARCELA AFECTADA
SELECT COUNT(*) INTO HAYDATOS FROM SCCI_PARCELA WHERE IDPARCELA = VIDPARCELA;
IF (HAYDATOS <> 0) THEN
SELECT SUPERFICIE INTO SUPERFICIEAFECTADA FROM SCCI_PARCELA WHERE IDPARCELA = VIDPARCELA;
HAYDATOS:=0; --INICIALIZO DE NUEVO DE LA VARIABLE
END IF;

-- SUMO LA NUEVA SUPERFICIE AFECTADA A LA HISTORICA
SUPERFICIEAFECTADATOTAL:= (SUPERFICIEAFECTADAHISTORICA + SUPERFICIEAFECTADA);

-- ACTUALIZO LOS DATOS DE LA ESTADISTICA

                UPDATE SCCI_ESTADISTICA1 SET
                SUPERFICIE = SUPERFICIEAFECTADATOTAL
                WHERE (ANUALIDAD = VANUALIDAD);


-- ACTUALIZO LA ESTADISTICA 2 QUE DERIVA DE ESTA

   SP_ESTADISTICA_2(VANUALIDAD, VIDPARCELA, RESPUESTA);
   
   
        RESPUESTA:='OK';
        RETURN;
                
           EXCEPTION
            WHEN OTHERS THEN
            
              err_num := SQLCODE; 
              err_msg := SQLERRM;
              RESPUESTA:= 'ERROR:' || err_num || err_msg ; --|| err_msg;
               
END;
END;

/




-- ESTADISTICA 2
-- ESTE PROCEDIMIENTO SE TENDR QUE EJECUTAR CADA VEZ QUE SE INTRODUZCA O MODIFIQUE UN INCENDIO O BIEN SE MODIFIQUE LA SUPERFICIE DE UNA PARCELA 
-- LOS INCENDIOS AFECTAN A UNA O VARIAS PARCELAS.
-- TENGO QUE CALCULAR EL SUMATORIO DE TODOS LOS CAMPOS SUPERFICIE DE LAS PARCELAS QUE ESTAN EN LA TABLA INCENDIO Y QUE ADEMAS TENGAN UNA PETICION EN ESE AO CON RESOLUCIN = 2. 
-- ES DECIR PARCELAS QUE HAN TENIDO UNA PETICION Y ESTA HA SIDO ACEPTADA Y POR LO TANTO SE HA HECHO UNA ACCION PREVENTIVA EN ELLA



CREATE OR REPLACE PROCEDURE "SP_ESTADISTICA_2"
(VANUALIDAD IN NUMBER,
VIDPARCELA IN NUMBER,
RESPUESTA OUT CHAR)
IS
BEGIN  

DECLARE

ERR_NUM NUMBER;
ERR_MSG VARCHAR2(255);
SUPERFICIEAFECTADAHISTORICA NUMBER;
SUPERFICIEAFECTADA NUMBER;
SUPERFICIEAFECTADATOTAL NUMBER;
VTOTALSUPERFICIEAFECTADA NUMBER;
HAYDATOS NUMBER:=0;
PORCENTAJE NUMBER;

BEGIN

-- PRIMERO CONSULTO EL TERRENOAFECTADO HISTORICO MIRANDO PRIMERO QUE HAYA DATOS PARA QUE NO ME D ERROR
SELECT COUNT(*) INTO HAYDATOS FROM SCCI_ESTADISTICA2 WHERE ANUALIDAD = VANUALIDAD;
IF (HAYDATOS <> 0) THEN
SELECT SUPERFICIEAFECTADACONPLAN INTO SUPERFICIEAFECTADAHISTORICA FROM SCCI_ESTADISTICA2 WHERE ANUALIDAD = VANUALIDAD;
HAYDATOS:=0; --INICIALIZO DE NUEVO DE LA VARIABLE
END IF;


-- CONSULTO LA SUPERFICIE DE LA PARCELA AFECTADA
-- CONSULTO SI LA PARCELA  QUE ESTOY TRATANDO TIENE SUPERFICIE QUE HA TENIDO UN PLAN DE PREVENCION ESE AO
SELECT COUNT(*) INTO HAYDATOS FROM SCCI_PARCELA PA, SCCI_PETICION PE WHERE PA.IDPARCELA = VIDPARCELA AND PA.IDPARCELA = PE.IDPARCELA AND PE.RESOLUCION = 2 AND PE.ANUALIDAD = VANUALIDAD;
IF (HAYDATOS <> 0) THEN
-- SI LA HA TENIDO ENTONCES LA SUPERFICIE AFECTADA CAMBIAR 
SELECT SUPERFICIE INTO SUPERFICIEAFECTADA FROM SCCI_PARCELA WHERE IDPARCELA = VIDPARCELA;
HAYDATOS:=0; --INICIALIZO DE NUEVO DE LA VARIABLE
END IF;

-- SUMO LA NUEVA SUPERFICIE AFECTADA A LA HISTORICA
SUPERFICIEAFECTADATOTAL:= (SUPERFICIEAFECTADAHISTORICA + SUPERFICIEAFECTADA);


-- ACTUALIZO EL DATO DE SUPERFICIE TOTAL

SELECT SUPERFICIE INTO VTOTALSUPERFICIEAFECTADA FROM SCCI_ESTADISTICA1 WHERE ANUALIDAD = VANUALIDAD;


--HAGO EL CALCULO PORCENTUAL
PORCENTAJE := (SUPERFICIEAFECTADATOTAL * 100) / VTOTALSUPERFICIEAFECTADA;

-- ACTUALIZO LOS DATOS DE LA ESTADISTICA

                UPDATE SCCI_ESTADISTICA2 SET
                SUPERFICIEAFECTADACONPLAN = SUPERFICIEAFECTADATOTAL,
                TOTALSUPERFICIEAFECTADA = VTOTALSUPERFICIEAFECTADA,
                PORCINCENDIO = PORCENTAJE
                WHERE (ANUALIDAD = VANUALIDAD);

        RESPUESTA:='OK';
        RETURN;
                
           EXCEPTION
            WHEN OTHERS THEN
            
              err_num := SQLCODE; 
              err_msg := SQLERRM;
              RESPUESTA:= 'ERROR:' || err_num || err_msg ; --|| err_msg;
               
END;
END;

/



-- ESTADISTICA 3
-- ESTE PROCEDIMIENTO SE TENDR QUE EJECUTAR CADA VEZ QUE SE INTRODUZCA UN INCENDIO O UNA MODIFICACION DEL PERFIL DE RIESGO DE LA PARCELA O UNA MODIFICACION DE LA VEGETACION
CREATE OR REPLACE PROCEDURE "SP_ESTADISTICA_3"
(RESPUESTA OUT CHAR)
IS
BEGIN  

DECLARE

ERR_NUM NUMBER;
ERR_MSG VARCHAR2(255);
HAYDATOS NUMBER:=0;
ANUALIDADENCURSO NUMBER;
FILAS NUMBER;

BEGIN

-- OBTENGO LA ANUALIDAD ACTUAL
SELECT EXTRACT(YEAR FROM sysdate) INTO ANUALIDADENCURSO FROM dual;


-- BORRO LA TABLA 

DELETE FROM SCCI_ESTADISTICA3;

-- ACTUALIZO LOS DATOS DE LA ESTADISTICA
INSERT INTO SCCI_ESTADISTICA3 (TOP5VEGETACIONID) 
SELECT IDVEGETACION FROM (
SELECT VE.IDVEGETACION, count(*) FROM SCCI_VEGETACION VE, SCCI_RIESGO RI, SCCI_PARCELA PA, SCCI_INCENDIO INC WHERE INC.IDPARCELA = PA.IDPARCELA AND PA.IDRIESGO = RI.IDRIESGO AND RI.IDVEGETACION = VE.IDVEGETACION AND INC.ACTIVO =1 AND INC.ANUALIDAD = ANUALIDADENCURSO GROUP BY VE.IDVEGETACION ORDER BY 2 DESC
)
WHERE ROWNUM <=5;





        RESPUESTA:='OK';
        RETURN;
                
           EXCEPTION
            WHEN OTHERS THEN
            
              err_num := SQLCODE; 
              err_msg := SQLERRM;
              RESPUESTA:= 'ERROR:' || err_num || err_msg ; --|| err_msg;
               
END;
END;

/




-- ESTADISTICA 4
-- ESTE PROCEDIMIENTO SE TENDR QUE EJECUTAR CADA VEZ QUE SE QUE SE REALICE UNA OPERACIN DE ADJUDICACIN DE UNA ACCIN PREVENTIVA
CREATE OR REPLACE PROCEDURE "SP_ESTADISTICA_4"
(
ANUALIDAD IN NUMBER,
RESPUESTA OUT CHAR)
IS
BEGIN  

DECLARE

ERR_NUM NUMBER;
ERR_MSG VARCHAR2(255);
HAYDATOS NUMBER:=0;
TOTALPROPIETARIOS NUMBER;
PROPIETARIOSCONACCION NUMBER;
PORCENTAJE NUMBER;
VANUALIDAD NUMBER;

BEGIN

VANUALIDAD := ANUALIDAD;

-- ACTUALIZO LOS DATOS DE LA ESTADISTICA


SELECT COUNT (*) INTO TOTALPROPIETARIOS FROM SCCI_PROPIETARIO;
SELECT COUNT(*) INTO PROPIETARIOSCONACCION FROM SCCI_PETICION WHERE RESOLUCION = 2 AND ANUALIDAD = VANUALIDAD;


--REALIZO LA OPERACION MATEMATICA
PORCENTAJE := (PROPIETARIOSCONACCION *100 )/ TOTALPROPIETARIOS;

                UPDATE SCCI_ESTADISTICA4 SET
                PORCPROPIETARIOS = PORCENTAJE
                WHERE (ANUALIDAD = VANUALIDAD);


        RESPUESTA:='OK';
        RETURN;
                
           EXCEPTION
            WHEN OTHERS THEN
            
              err_num := SQLCODE; 
              err_msg := SQLERRM;
              RESPUESTA:= 'ERROR:' || err_num || err_msg ; --|| err_msg;
               
END;
END;

/




-- ESTADISTICA 5
-- ESTE PROCEDIMIENTO SE TENDR QUE EJECUTAR CADA VEZ QUE SE INTRODUZCA O MODIFIQUE UN INCENDIO O EL PERFIL DE RIESGO DE UNA PARCELA.
CREATE OR REPLACE PROCEDURE "SP_ESTADISTICA_5"
(
RESPUESTA OUT CHAR)
IS
BEGIN  

DECLARE

ERR_NUM NUMBER;
ERR_MSG VARCHAR2(255);
HAYDATOS NUMBER:=0;
TOTALPROPIETARIOS NUMBER;
PROPIETARIOSCONACCION NUMBER;
PORCENTAJE NUMBER;
VANUALIDAD NUMBER;

BEGIN



-- BORRO LA TABLA 

DELETE FROM SCCI_ESTADISTICA5;

-- ACTUALIZO LOS DATOS DE LA ESTADISTICA
INSERT INTO SCCI_ESTADISTICA5 (IDVEGETACION) 
SELECT IDVEGETACION FROM (
SELECT VE.IDVEGETACION, count(*) FROM SCCI_VEGETACION VE, SCCI_RIESGO RI, SCCI_PARCELA PA, SCCI_INCENDIO INC WHERE INC.IDPARCELA = PA.IDPARCELA AND PA.IDRIESGO = RI.IDRIESGO AND RI.IDVEGETACION = VE.IDVEGETACION AND INC.ACTIVO =1 GROUP BY VE.IDVEGETACION ORDER BY 2 DESC
)
WHERE ROWNUM <=1;


        RESPUESTA:='OK';
        RETURN;
                
           EXCEPTION
            WHEN OTHERS THEN
            
              err_num := SQLCODE; 
              err_msg := SQLERRM;
              RESPUESTA:= 'ERROR:' || err_num || err_msg ; --|| err_msg;
               
END;
END;

/


-- ESTADISTICA 6
-- ESTE PROCEDIMIENTO SE TENDR QUE EJECUTAR CADA VEZ QUE SE INTRODUZCA UN GASTO
CREATE OR REPLACE PROCEDURE "SP_ESTADISTICA_6"
(
RESPUESTA OUT CHAR)
IS
BEGIN  

DECLARE

ERR_NUM NUMBER;
ERR_MSG VARCHAR2(255);



BEGIN


-- BORRO LA TABLA 
DELETE FROM SCCI_ESTADISTICA6;
dbms_output.put_line ('entra');  
--CONSULTO EL IMPORTEMAX - GASTO DE CADA ANUALIDAD
INSERT INTO SCCI_ESTADISTICA6 (ANUALIDAD)
SELECT ANUALIDAD FROM (
SELECT ANUALIDAD, (IMPORTEMAXIMO - GASTOANUALIDAD) AS DIFERENCIA FROM (
SELECT ANUALIDAD, SUM(IMPORTEMAX) AS IMPORTEMAXIMO, SUM(GASTOACTUAL) AS GASTOANUALIDAD FROM SCCI_SUBVENCION GROUP BY ANUALIDAD) ORDER BY DIFERENCIA DESC
) WHERE ROWNUM <=1;


        RESPUESTA:='OK';
        RETURN;
                
           EXCEPTION
            WHEN OTHERS THEN
            
              err_num := SQLCODE; 
              err_msg := SQLERRM;
              RESPUESTA:= 'ERROR:' || err_num || err_msg ; --|| err_msg;
               
END;
END;

/


-- ESTADISTICA 7
-- ESTE PROCEDIMIENTO SE TENDR QUE EJECUTAR CADA VEZ QUE SE INTRODUZCA O MODIFIQUE UN INCENDIO
CREATE OR REPLACE PROCEDURE "SP_ESTADISTICA_7"
(
RESPUESTA OUT CHAR)
IS
BEGIN  

DECLARE

ERR_NUM NUMBER;
ERR_MSG VARCHAR2(255);
ANUALIDADACTUAL NUMBER;
ANUALIDADANTERIOR NUMBER;
INCENDIOACTUAL NUMBER;
INCENDIOPASADO NUMBER;
PORCENTAJE NUMBER;


BEGIN

--OBTENGO LA ANUALIDAD ACTUAL
SELECT EXTRACT(YEAR FROM sysdate) INTO ANUALIDADACTUAL FROM dual;

--POR TANTO
ANUALIDADANTERIOR := ANUALIDADACTUAL -1 ;


-- BORRO LA TABLA 
DELETE FROM SCCI_ESTADISTICA7;

-- CONSULTO EL NUMERO DE INCENDIOS DE LA ANUALIDAD PASADA

SELECT COUNT(*) INTO INCENDIOPASADO FROM SCCI_INCENDIO WHERE ANUALIDAD = ANUALIDADANTERIOR;


SELECT COUNT(*) INTO INCENDIOACTUAL FROM SCCI_INCENDIO WHERE ANUALIDAD = ANUALIDADACTUAL;


PORCENTAJE:=  100 - ( ( INCENDIOPASADO *100) / INCENDIOACTUAL);

-- CONSULTO EL NUMERO DE INCENDIOS QUE LLEVA ESTA ANUALIDAD
INSERT INTO SCCI_ESTADISTICA7 (PORCDIFINCENDIO) VALUES (PORCENTAJE);


        RESPUESTA:='OK';
        RETURN;
                
           EXCEPTION
            WHEN OTHERS THEN
            
              err_num := SQLCODE; 
              err_msg := SQLERRM;
              RESPUESTA:= 'ERROR:' || err_num || err_msg ; --|| err_msg;
               
END;
END;

/






-- ESTADISTICA 8
-- ESTE PROCEDIMIENTO SE TENDR QUE EJECUTAR CADA VEZ QUE SE INTRODUZCA O MODIFIQUE O SE ELIMINE UNA PARCELA O MODIFIQUE UN RIESGO
CREATE OR REPLACE PROCEDURE "SP_ESTADISTICA_8"
(
RESPUESTA OUT CHAR)
IS
BEGIN  

DECLARE

ERR_NUM NUMBER;
ERR_MSG VARCHAR2(255);



BEGIN


-- BORRO LA TABLA 
DELETE FROM SCCI_ESTADISTICA8;

-- CONSULTO LAS PARCELAS CON SU VALOR DE RIESGO Y OBTENGO LAS 10 MAYORES

INSERT INTO SCCI_ESTADISTICA8 (TOP10PARCELAS)
SELECT IDPARCELA FROM (
SELECT PARC.IDPARCELA, RIES.VALORRIESGO FROM SCCI_PARCELA PARC, SCCI_RIESGO RIES WHERE PARC.IDRIESGO = RIES.IDRIESGO ORDER BY RIES.VALORRIESGO DESC)

WHERE ROWNUM <=10;


        RESPUESTA:='OK';
        RETURN;
                
           EXCEPTION
            WHEN OTHERS THEN
            
              err_num := SQLCODE; 
              err_msg := SQLERRM;
              RESPUESTA:= 'ERROR:' || err_num || err_msg ; --|| err_msg;
               
END;
END;

/







-- ESTADISTICA 8
-- ESTE PROCEDIMIENTO SE TENDR QUE EJECUTAR CADA VEZ QUE SE INTRODUZCA O MODIFIQUE O SE ELIMINE UNA PARCELA O MODIFIQUE UN RIESGO
CREATE OR REPLACE PROCEDURE "SP_ESTADISTICA_9"
(
RESPUESTA OUT CHAR)
IS
BEGIN  

DECLARE

ERR_NUM NUMBER;
ERR_MSG VARCHAR2(255);
SUPERFICIETOTAL NUMBER;
SUPERFICIEACTUACION NUMBER;




BEGIN


-- BORRO LA TABLA 
DELETE FROM SCCI_ESTADISTICA9;



-- CONSULTO LA SUPERFICIE TOTAL DE LAS PARCELAS

SELECT SUM(SUPERFICIE) INTO SUPERFICIETOTAL FROM SCCI_PARCELA;


-- CONSULTO POR AO LA SUPERFICIE DE PARCELAS CON ACTUACIONES
INSERT INTO  SCCI_ESTADISTICA9 (ANUALIDAD, PORCEXITO)
SELECT PE.ANUALIDAD, ((SUM(PA.SUPERFICIE) /SUPERFICIETOTAL)*100) AS PORCENTAJE FROM SCCI_PARCELA PA, SCCI_PETICION PE WHERE PA.IDPARCELA = PE.IDPARCELA AND PE.RESOLUCION = 2 GROUP BY ANUALIDAD;


        RESPUESTA:='OK';
        RETURN;
                
           EXCEPTION
            WHEN OTHERS THEN
            
              err_num := SQLCODE; 
              err_msg := SQLERRM;
              RESPUESTA:= 'ERROR:' || err_num || err_msg ; --|| err_msg;
               
END;
END;

/












